X,Y=love.graphics.getDimensions()
love.run= function()
 love.handlers.quit=os.exit
 love.timer.step()
 return function()  
  love.event.pump()
   for name, a,b,c,d,e,f in love.event.poll() do
    love.handlers[name](a,b,c,d,e,f)
   end
  love.update(love.timer.step())  
  love.graphics.present()
  love.timer.sleep(0.00001)
 end
end
Map=setmetatable({},{__index=function(_, x) _[x]={} return _[x] end})
function Mapmaker(lenght)
 Crossings={}
 Map=setmetatable({},{__index=function(_, x) _[x]={} return _[x] end})
 Map[1]={1}
 local cx,cy,count1,count2,dr=1,1,0,0
 repeat
  dr=select(math.random(3),math.random(4),dr,dr,dr)
  if dr==1 and not (Map[cy+1][cx+1] or Map[cy-1][cx+1] or Map[cy][cx+1] or Map[cy][cx+2] ) then 
   cx=cx+1   
   Map[cy][cx]=1
   count1=count1+1
  elseif dr==2 and not (Map[cy+1][cx-1] or Map[cy-1][cx-1] or Map[cy][cx-1] or Map[cy][cx-2] ) then 
   cx=cx-1   
   Map[cy][cx]=1
   count1=count1+1
  elseif dr==3 and not (Map[cy-1][cx+1] or Map[cy-1][cx-1] or Map[cy-1][cx] or Map[cy-2][cx] ) then 
   cy=cy-1   
   Map[cy][cx]=1
   count1=count1+1
  elseif dr==4 and not (Map[cy+1][cx+1] or Map[cy+1][cx-1] or Map[cy+1][cx] or Map[cy+2][cx] ) then 
   cy=cy+1   
   Map[cy][cx]=1
   count1=count1+1
  end   
  count2=count2+1
  if count2%40 then Crossings[#Crossings+1]={cy,cx} end
 until count1==lenght or count2==lenght*2
 Map[cy][cx]=3
 if count2==lenght*2 then return Mapmaker(lenght) end
end
function Crossmaker(lenght)
  for k,v in ipairs(Crossings) do
  local count1,count2=1,1
  local cy,cx=v[1],v[2]
  local straig=math.random(5)
  repeat
   dr=select(math.random(straig),math.random(4),dr,dr,dr,dr)
   if dr==1 and not (Map[cy+1][cx+1] or Map[cy-1][cx+1] or Map[cy][cx+1]  ) then 
    cx=cx+1   
    Map[cy][cx]=2
    count1=count1+1
   elseif dr==2 and not (Map[cy+1][cx-1] or Map[cy-1][cx-1] or Map[cy][cx-1]  ) then 
    cx=cx-1   
    Map[cy][cx]=2
    count1=count1+1
   elseif dr==3 and not (Map[cy-1][cx+1] or Map[cy-1][cx-1] or Map[cy-1][cx]  ) then 
    cy=cy-1   
    Map[cy][cx]=2
    count1=count1+1
   elseif dr==4 and not (Map[cy+1][cx+1] or Map[cy+1][cx-1] or Map[cy+1][cx]  ) then 
    cy=cy+1   
    Map[cy][cx]=2
    count1=count1+1
   end   
   count2=count2+1
  until count1==lenght or count2==lenght*2
 end
end
math.randomseed(love.math.random())
Mapmaker(300)
Crossmaker(100)
Car={}
Scale=.5		
SFC=X/1550*200*Scale
SF=SFC/200
Car.long=SFC*1.5/4
Car.width=SFC/4
Car.image=love.graphics.newCanvas(Car.width,Car.long)
love.graphics.setCanvas(Car.image)
love.graphics.clear({0.11,0.35,0.18})
love.graphics.setColor({0.85,0.97,0.99})
love.graphics.circle("fill",0,0,SFC/15)
love.graphics.circle("fill",Car.width,0,SFC/15)
love.graphics.setColor({0.99,0.35,0.35})
love.graphics.circle("fill",Car.width,Car.long,SFC/15)
love.graphics.circle("fill",0,Car.long,SFC/15)
love.graphics.setCanvas()
Car.speed=0
Car.brakes=90*SF
Car.sane=50*SF
Car.turn=.008	/SF								
Car.accel=20*SF
Car.reverse=-40*SF
Car.d=math.pi/2		
Car.x=Car.width/2+SFC/2	
Car.y=Car.width/2+SFC/2			
Tilesx=math.ceil(X/SFC/2)
Tilesy=math.ceil(Y/SFC/2)
Text=""
love.graphics.setFont(love.graphics.newFont( Y/20 ))
function Dummy() end	
Steer=Dummy
C={}
C.start=function()
 if math.abs(Car.speed)<0.2 then
  Steer=function(dt)
   Car.speed=Car.speed+Car.accel*dt
   if Car.speed>Car.sane then 
    Steer=Dummy
   end
  end
 end
end
C.drive=function()
 Steer=function(dt)
  Car.speed=Car.speed+Car.accel*dt
  if Car.speed>Car.sane then 
   Steer=Dummy
  end
 end
end
C.confuse=function()
 local timer=0
 local spee=math.random()*math.random(-15,15)
 local con=math.random()*math.random(-1,1)
 Steer=function(dt)
  love.graphics.setColor({0.99,0.08,0.03})
  love.graphics.printf("What?",0,Y*.8,X,"center")
  Car.speed=Car.speed+Car.accel*spee*dt
  Car.d=Car.d+Car.turn*Car.speed*con*dt
  Car.d=Car.d%(math.pi*2)
  timer=timer+dt
  if timer>1 then  Steer=Dummy 	end
 end
end
C.dragster=function()
 if math.abs(Car.speed)==0 then
  Steer=function(dt)
   Car.speed=Car.speed+Car.accel*10*dt
  end
 end
end
C.stop=function()
 if Car.speed>0 then
  Steer=function(dt)
   Car.speed=Car.speed-Car.brakes*dt
   if Car.speed<0 then 
    Steer=Dummy
    Car.speed=0
   end
  end
 else
  Steer=function(dt)
   Car.speed=Car.speed+Car.brakes*dt
   if Car.speed>0 then 
    Steer=Dummy
    Car.speed=0
   end
  end
 end
end
C.faster=function()
 local ospeed=Car.speed
 if Car.speed>=0 then
  Steer=function(dt)
   Car.speed=Car.speed+Car.accel*dt
   if Car.speed>ospeed*1.5 then 
    Steer=Dummy
   end
  end
 else
  Steer=function(dt)
   Car.speed=Car.speed-Car.accel*dt
   if Car.speed<ospeed*1.5 then 
    Steer=Dummy
   end
  end
 end
end
C.slower=function()
 local ospeed=Car.speed
 if Car.speed>0 then
  Steer=function(dt)
   Car.speed=Car.speed-Car.accel*dt
   if Car.speed<ospeed/1.5 then 
    Steer=Dummy
   end
  end
 else
  Steer=function(dt)
   Car.speed=Car.speed+Car.accel*dt
   if Car.speed>ospeed*1.5 then 
    Steer=Dummy
   end
  end
 end
end
C.right=function()
 local od=Car.d
 Steer=function(dt)
  Car.d=Car.d+Car.turn*Car.speed*dt
  if Car.d>(od+math.pi/2) then 
   Car.d=Car.d%(math.pi*2)
   Steer=Dummy
  end
 end
end
C.left=function()
 local od=Car.d
 Steer=function(dt)
  Car.d=Car.d-Car.turn*Car.speed*dt
  if Car.d<(od-math.pi/2) then 
   Car.d=Car.d%(math.pi*2)
   Steer=Dummy
  end
 end
end
C.leftlane=function()
 if Car.speed<0 then return end
 local od=Car.d
 Steer=function(dt)
  Car.d=Car.d-Car.turn*Car.speed*dt
  if Car.d<(od-math.pi/4) then 
   Steer=function(dt)
    Car.d=Car.d+Car.turn*Car.speed*dt
    if Car.d>od then 
     Car.d=Car.d%(math.pi*2)
     Steer=Dummy
    end
   end
  end
 end
end
C.rightlane=function()
 if Car.speed<0 then return end	
 local od=Car.d
 Steer=function(dt)
  Car.d=Car.d+Car.turn*Car.speed*dt
  if Car.d>(od+math.pi/4) then 
   Steer=function(dt)
    Car.d=Car.d-Car.turn*Car.speed*dt
    if Car.d<od then 
     Car.d=Car.d%(math.pi*2)
     Steer=Dummy
    end
   end
  end
 end
end
C.straight=function()
 Steer=Dummy
end
C.reverse=function()
 if Car.speed==0 then
  Steer=function(dt)
   Car.speed=Car.speed-Car.accel*dt
   if Car.speed<Car.reverse then 
    Steer=Dummy
   end
  end
 end
end
C.r=C.right
C.s=C.stop
C.sl=C.slower
C.back=C.reverse
C.b=C.reverse
C.l=C.left
C.ll=C.leftlane
C.rl=C.rightlane
C["left lane"]=C.leftlane
C["right lane"]=C.rightlane
C.go=C.start
C.f=C.faster
C["GO!"]=C.dragster
C.drag=C.dragster
C.brake=C.stop
C.fw=C.drive
C.d=C.drive
C.forward=C.drive
function love.update(dt)
 love.graphics.clear({0.1,0.1,0.5})
 local mccx=math.floor(Car.x/SFC)
 local mccy=math.floor(Car.y/SFC) 		
 for x=mccx-Tilesx,Tilesx+mccx+1 do
  for y=mccy-Tilesy,Tilesy+mccy+1 do
   if Map[y][x]==1 then
    love.graphics.setColor({0.99,0.54,0.58}	)
    love.graphics.rectangle("fill",-Car.x+x*SFC+X/2-SFC,-Car.y+y*SFC+Y/2-SFC, SFC,SFC)
   elseif Map[y][x]==2 then
    love.graphics.setColor({0.81,0.73,0.85})
    love.graphics.rectangle("fill",-Car.x+x*SFC+X/2-SFC,-Car.y+y*SFC+Y/2-SFC, SFC,SFC)
   elseif Map[y][x]==3 then
    love.graphics.setColor(math.random(),math.random(),math.random())
    love.graphics.rectangle("fill",-Car.x+x*SFC+X/2-SFC,-Car.y+y*SFC+Y/2-SFC, SFC,SFC)
   end
  end
 end
 Steer(dt)
 local togoy=Car.y-(Car.speed*math.cos(Car.d)*dt)
 local togox=Car.x+(Car.speed*math.sin(Car.d)*dt)
 if Map[math.ceil(togoy/SFC)][math.ceil(togox/SFC)] then
  Car.y=togoy
  Car.x=togox
 else
  Car.speed=0
 end
 love.graphics.setColor(1,1,1)
 love.graphics.draw(Car.image,X/2,Y/2,Car.d,1,1,Car.width/2,Car.long/2)
 love.graphics.print("right\nstraight\nslower\nreverse\nleft\nleftlane\nrightlane\nstart\nfaster\nGO!\nstop\ndrive\n")
 love.graphics.printf(Text,0,Y*.9,X,"center")
end
function love.textinput(tips)
 Text=Text..tips
end
function love.keypressed(k)
 if k=="return" then 
  if C[Text] then 
   C[Text]() 
  else  
   C.confuse()		
  end
  Text=""
 elseif k=="backspace" then 
  Text=""
 end
end
